unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls, Spin, Menus, Buttons;

type
  TCM6337_1 = class(TForm)
    StatusBar1: TStatusBar;
    pcFeauts: TPageControl;
    PageSets: TTabSheet;
    PageCtrA: TTabSheet;
    WidthSet: TGroupBox;
    StyleSet: TGroupBox;
    PageSymb: TTabSheet;
    pgTxtEdt: TTabSheet;
    Empty4: TTabSheet;
    Empty5: TTabSheet;
    PageGraf: TTabSheet;
    WidExten: TCheckBox;
    WidElite: TCheckBox;
    StDouble: TCheckBox;
    StQuanty: TCheckBox;
    Language: TRadioGroup;
    LangAltM: TRadioButton;
    LangKoi8: TRadioButton;
    LangComn: TRadioButton;
    StrOutPr: TEdit;
    SetPrint1: TButton;
    Instruc: TButton;
    HeighSet: TGroupBox;
    Hei2spi: TRadioButton;
    Hei3spi: TRadioButton;
    Hei4spi: TRadioButton;
    Hei0353: TRadioButton;
    Hei0118: TRadioButton;
    Wid12smb: TRadioButton;
    Wid10smb: TRadioButton;
    SpinEdit1: TSpinEdit;
    SpinEdit2: TSpinEdit;
    imMyPrnt: TImage;
    mnMain: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    mmText: TMemo;
    pnTextBt: TPanel;
    btLoadTx: TButton;
    btPrinTx: TButton;
    About2: TMenuItem;
    MergeText1: TMenuItem;
    SaveText1: TMenuItem;
    Save2: TMenuItem;
    File2: TMenuItem;
    Save3: TMenuItem;
    Save4: TMenuItem;
    N1: TMenuItem;
    Quit1: TMenuItem;
    btMergTx: TButton;
    QuitNoSv: TButton;
    QuitSave: TButton;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    odOpenTx: TOpenDialog;
    PrnName: TEdit;
    edTextFN: TEdit;
    fdFontTx: TFontDialog;
    lbLnTx: TLabel;
    edLnTx: TEdit;
    lbPgTx: TLabel;
    edPgTx: TEdit;
    lbLPtx: TLabel;
    edLPtx: TEdit;
    InitCrLf: TCheckBox;
    cbLfCrTx: TCheckBox;
    bbNxPage: TBitBtn;
    lbCurXps: TLabel;
    lbCurYps: TLabel;
    edCurXps: TEdit;
    edCurYps: TEdit;
    cbNxPage: TCheckBox;
    procedure QuitNoSvClick(Sender: TObject);
    procedure QuitSaveClick(Sender: TObject);
    procedure SetPrint1Click(Sender: TObject);
    procedure LangAltMMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LangKoi8MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure LangComnMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure SetPrint1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure InstrucMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WidEliteMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WidExtenMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Wid12smbMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Wid10smbMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StDoubleMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StQuantyMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StatusBar1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PageSetsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure WidthSetMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StyleSetMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure StrOutPrMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormHeadMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure pcFeautsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btLoadTxMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btLoadTxClick(Sender: TObject);
    procedure HeighSetMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Hei3spiMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Hei4spiMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Hei2spiMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure btMergTxClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btPrinTxClick(Sender: TObject);
    procedure mmTextChange(Sender: TObject);
    procedure mmTextMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure mmTextMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mmTextMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mmTextKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure edLPtxChange(Sender: TObject);
    procedure bbNxPageClick(Sender: TObject);
  private
    { Private declarations }
  public    { Public declarations }
    function  Translat(ch_in:Char; tp:Integer):Char;
    procedure PrnStr(ss:String);
    procedure MergeText;
    procedure ShowLongHint(Sender: TObject);
    procedure OutTextLength;
    procedure OutCursCoord; //     
  end;

const
  pAlready: Boolean=False;             //   
  TrIndent: Integer=0;                 //  .
  c_Esc   : String[1]=#27;             //   .
  c_Eol   : String[2]=#13#10;          //  / .
  c_Init  : String[2]=#27#64;          //  .
  c_Alt   : String[3]=#27#82#15;       //  .
  c_Koi   : String[3]=#27#82#15;       //  .
  c_Com   : String[3]=#27#82#15;       //  .
  c_dEt   : String[1]=#15;             //   .
  c_dEf   : String[1]=#18;             //   .
  c_dXt   : String[1]=#14;             //   .
  c_dXf   : String[1]=#20;             //   .
  c_d12   : String[2]=#27#77;          //  12   .
  c_d10   : String[2]=#27#80;          //  10   .
  c_v2s   : String[2]=#27#49;          //  2,54 mm  .
  c_v3s   : String[2]=#27#48;          //  3,175 mm  .
  c_v4s   : String[2]=#27#50;          //  4,23 mm  .
  c_dSt   : String[2]=#27#69;          //   .
  c_dSf   : String[2]=#27#70;          //   .
  c_dDt   : String[2]=#27#71;          //   .
  c_dDf   : String[2]=#27#72;          //   .

var
  CM6337_1: TCM6337_1;
  FileName: String;


implementation

{$R *.DFM}

function TCM6337_1.Translat(ch_in:Char; tp:Integer):Char;
var
  chout:Char;
begin
  if (tp=TrIndent) then chout:=ch_in;

  Translat:=chout;
end;

procedure TCM6337_1.PrnStr(ss:String);
var
  FileHandle : Integer;
  FileName   : String;
  SymArr     : String;
  i, lss     : Integer;
begin
//  ss:=ss+c_Eol;
  lss:=Length(ss);
  SymArr:=ss;
{  for i:=1 to lss do
    SymArr[i]:=Translat(ss[i],TrIndent);}

  FileName:=PrnName.Text;
  FileHandle:=FileCreate(FileName);

  if (FileHandle>0) then
    begin
      FileWrite(FileHandle, SymArr[1], lss);
      FileClose(FileHandle);
    end
  else
    close;
end;

procedure TCM6337_1.QuitNoSvClick(Sender: TObject);
begin
  Close;
end;

procedure TCM6337_1.QuitSaveClick(Sender: TObject);
begin
  Close;
end;

procedure TCM6337_1.SetPrint1Click(Sender: TObject);
var
  InitStr:String;
begin
  InitStr:=c_Init;                     //  .

 {  . }
  if (LangAltM.Checked=True) then  InitStr:=InitStr+c_Alt;
  if (LangKoi8.Checked=True) then  InitStr:=InitStr+c_Koi;
  if (LangComn.Checked=True) then  InitStr:=InitStr+c_Com;

 {   . }
  if (WidElite.Checked=True) then  InitStr:=InitStr+c_dEt
                             else  InitStr:=InitStr+c_dEf;
  if (WidExten.Checked=True) then  InitStr:=InitStr+c_dXt
                             else  InitStr:=InitStr+c_dXf;
  if (Wid12smb.Checked=True) then  InitStr:=InitStr+c_d12;
  if (Wid10smb.Checked=True) then  InitStr:=InitStr+c_d10;

 {   . }
  if (Hei2spi.Checked=True) then  InitStr:=InitStr+c_v2s;
  if (Hei3spi.Checked=True) then  InitStr:=InitStr+c_v3s;
  if (Hei4spi.Checked=True) then  InitStr:=InitStr+c_v4s;

 {   . }
  if (StQuanty.Checked=True) then  InitStr:=InitStr+c_dSt
                             else  InitStr:=InitStr+c_dSf;
  if (StDouble.Checked=True) then  InitStr:=InitStr+c_dDt
                             else  InitStr:=InitStr+c_dDf;

  InitStr:=InitStr+StrOutPr.Text;
  if (InitCrLf.Checked=True) then  InitStr:=InitStr + c_Eol;
  InitStr:=InitStr + #13;
  PrnStr(InitStr);
end;

procedure TCM6337_1.LangAltMMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.LangKoi8MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' -8  (UNIX-)';
end;

procedure TCM6337_1.LangComnMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.SetPrint1MouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.InstrucMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.WidEliteMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.WidExtenMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.Wid12smbMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' 12   ';
end;

procedure TCM6337_1.Wid10smbMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' 10   ';
end;

procedure TCM6337_1.StDoubleMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.StQuantyMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.StatusBar1MouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.PageSetsMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' " "';
end;

procedure TCM6337_1.WidthSetMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.StyleSetMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  StatusBar1.SimpleText:=' () ';
end;

procedure TCM6337_1.StrOutPrMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='   ';
end;

procedure TCM6337_1.FormHeadMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.pcFeautsMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.btLoadTxMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:=' ';
end;

procedure TCM6337_1.MergeText;
var
  OneStr, ss : String;
  FilVar     : TextFile;
  i          : Integer;
begin
  AssignFile(FilVar, FileName);
  try
    ReSet(FilVar);
  except
    Exit;
  end;

  mmText.Visible:=False;               //   
  while (not EOF(FilVar)) do
   begin
    ReadLn(FilVar, OneStr);
    if (cbLfCrTx.Checked=True) then
     begin
      ss:='';
      for i:=1 to Length(OneStr) do
        if (OneStr[i] = #10) then ss:=ss+#13#10
                             else ss:=ss+OneStr[i];
      OneStr:=ss;
     end;
    mmText.Lines.Add(OneStr);
   end;
  CloseFile(FilVar);
  mmText.Visible:=True;                //  
end;

procedure TCM6337_1.btLoadTxClick(Sender: TObject);
begin
  mmText.Lines.Clear;
  btMergTxClick(Sender);
end;

procedure TCM6337_1.HeighSetMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  ';
end;

procedure TCM6337_1.Hei3spiMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  3,175 mm';
end;

procedure TCM6337_1.Hei4spiMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  4,23 mm';
end;

procedure TCM6337_1.Hei2spiMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: Integer);
begin
  StatusBar1.SimpleText:='  2,54 mm';
end;

procedure TCM6337_1.btMergTxClick(Sender: TObject);
begin
  odOpenTx.Filter := ' |*.txt| |*.*';
  if odOpenTx.Execute and FileExists(odOpenTx.FileName) then
   begin
    FileName := odOpenTx.FileName;
    MergeText;
    edTextFN.Text := FileName;  edTextFN.SelectAll;
   end
end;

procedure TCM6337_1.ShowLongHint(Sender: TObject);
begin
  StatusBar1.SimpleText := Application.Hint;
end;

procedure TCM6337_1.FormCreate(Sender: TObject);
begin
  Application.OnHint := ShowLongHint;
end;

procedure TCM6337_1.btPrinTxClick(Sender: TObject);
var
  txt:String;
begin
  if (Not(pAlready)) then
   begin
    pAlready:=True;                    // 
    btPrinTx.Enabled:=False;           //  

    if (mmText.SelLength=0)            //    
     then txt:=mmText.Text             //  ,   ,
     else txt:=mmText.SelText;         //   -  

    if (cbNxPage.Checked=True) then txt:=txt+#12;
    PrnStr(txt);
    btPrinTx.Enabled:=True;            // 
    pAlready:=False;                   //  
   end; // pAlready=True
end;


//     
procedure TCM6337_1.OutTextLength;
var
  txt:        String;
  i, ln, sco: Integer;
begin
  if (mmText.SelLength=0)
    then txt:=mmText.Text
    else txt:=mmText.SelText;

  ln := Length(txt);
  sco:= 1;
  i:=Pos(#13,txt);
  while i<>0 do
   begin
    Inc(sco);
    Delete(txt,1,i);
    i:=Pos(#13,txt);
   end;
  edLnTx.Text:=IntToStr(sco);
  edPgTx.Text:=IntToStr(sco div StrToInt(edLPtx.Text) +1);
end;  // OutTextLength


//     
procedure TCM6337_1.OutCursCoord;
var
//  txt : String;
  X, Y: Longint;
begin
  Y:=mmText.Perform(EM_LINEFROMCHAR, mmText.SelStart, 0);
  X:=mmText.Perform(EM_LINEINDEX, Y, 0);
  Inc(Y);
  X:=mmText.SelStart-X+1;
  edCurXps.Text:=IntToStr(X);
  edCurYps.Text:=IntToStr(Y);
end;  // OutCursCoord


procedure TCM6337_1.mmTextChange(Sender: TObject);
begin
  OutTextLength;
  OutCursCoord;
end;

procedure TCM6337_1.mmTextMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  OutTextLength;
  OutCursCoord;
end;

procedure TCM6337_1.mmTextMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  OutTextLength;
  OutCursCoord;
end;

procedure TCM6337_1.mmTextMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  OutTextLength;
  OutCursCoord;
end;

procedure TCM6337_1.mmTextKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  OutTextLength;
  OutCursCoord;
end;

procedure TCM6337_1.edLPtxChange(Sender: TObject);
begin
  OutTextLength;
end;


//  [ ]
procedure TCM6337_1.bbNxPageClick(Sender: TObject);
var
  txt:String;
begin
  txt:=#12;
  PrnStr(txt);
end;

end.

